const fs = require('fs');
const csstree = require('css-tree');

// const filename = 'react-mdn.5b7ff2245ae8.css';
const filename = process.argv[2];

const css = fs.readFileSync(filename, 'utf8').trim();
var ast = csstree.parse(css, {
  filename: filename,
  positions: true,
  onParseError: function(error) {
    errors.push(error);
  }
});

// console.log(ast);

// const selectorAst = cssTree.parse(css, { context: 'selector' });

const printed = new Set();
const names = [];
csstree.walk(ast, {
  visit: 'Rule',
  enter: function(node) {
    // console.log(node);
    // if (!printed.has(node.name)) {
    node.prelude.children.forEach((node, item, list) => {
      const s = csstree.generate(node);
      // console.log(typeof s);
      if (!printed.has(s)) {
        names.push(s);
        printed.add(s);
      }
    });
    //   names.push(node.name);
    //   printed.add(node.name);
    // }
  }
});

names.sort();
names.forEach(n => {
  console.log(n);
});
