const puppeteer = require('puppeteer');

//const URL = 'https://googlechrome.github.io/samples/service-worker/basic/';
const URL = 'https://www.peterbe.com/';
// const URL = 'https://songsear.ch/';

// enables request interception but allow everything
async function mockPage(page) {
  await page.setRequestInterception(true);
  await page.on('request', req => req.continue());
}

async function main() {
  const browser = await puppeteer.launch({
    headless: false,
    devtools: true,
    args: ['--enable-features=NetworkService']
  });
  const page = await browser.newPage();
  await page._client.send('ServiceWorker.disable');
  //await page._client.send('ServiceWorker.stopAllWorkers');

  await mockPage(page);

  await page.goto(URL);
}

main()
  .then(data => console.log(data))
  .catch(err => console.error(err));
